#!/bin/bash
cd /home/volumio/Change_touchscreen
cp -r node_modules/ini /data/plugins/miscellanea/touch_display/node_modules/

[ ! -d "backup/i18n" ] && mkdir -p backup/i18n
STR=/data/plugins/miscellanea/touch_display/i18n/strings_de.json
if ! grep -q 'VU-Meter' $STR; then
	cp -f $STR backup/i18n
	sudo sed -i '/"TOUCH_DISPLAY":/a\
    "METER":"VU-Meter",\
    "METER_DOC":"Alle VU-Meter des aktiven Meter-Ordners (nur aktiviert, wenn die Option '\''Kein Bildschirmschoner während Wiedergabe'\'' eingeschaltet ist",\
    "LIST_EMPTY":"Keine VU-Meters in der Liste. Random Mode wird wieder eingeschaltet!",\
    "RANDOMSELECTION":"VU-Meter für Liste",\
    "RANDOMSELECTION_DOC":"Komma-getrennte Liste von VU-Meternamen die bei Auswahl von '\''List'\'' verwendet werden.<br />Verfügbare Meternamen zum Kopieren-Einfügen:<br /><br />",\
    "RANDOMINTERVAL":"Random-Intervall",\
    "RANDOMINTERVAL_DOC":"Zeitintervall bis das nächste VU_Meter angezeigt wird",\
    "NEEDLE_CACHE":"Needle Cache",\
    "NEEDLE_CACHE_DOC":"Ein Raspberry mit 1GB RAM und einer Displayauflösung von 1920x1080 oder 1280x800 ist hart am Speicherlimit. Deshalb muss der Cache abgeschaltet werden, um Speicher zu sparen. Ansonsten ist kein Random- oder List-Modus möglich",\
    "SCREEN_WIDTH":"Bildschrimauflösung (Breite)",\
    "SCREEN_WIDTH_DOC":"Die Angabe der Bildschirmauflösung ist nur für die Verwendung eines '\''Custom-Folders'\'' mit Hintergrundbild notwendig",\
    "SCREEN_HEIGHT":"Bildschrimauflösung (Höhe)",\
    "SCREEN_HEIGHT_DOC":"Die Angabe der Bildschirmauflösung ist nur für die Verwendung eines '\''Custom-Folders'\'' mit Hintergrundbild notwendig",\
    "ACTIVE_FOLDER":"Aktiver VU_Meter Ordner",\
    "ACTIVE_FOLDER_DOC":"Auswahl des aktiv verwendeten Ordners für VU-Meter (für die '\''Custom-Folder'\'' mit Hintergrundbild ist die Angabe der  Bildschirmauflösung zwingend",' $STR
fi
STR=/data/plugins/miscellanea/touch_display/i18n/strings_en.json
if ! grep -q 'VU-Meter' $STR; then
	cp -f $STR backup/i18n
	sudo sed -i '/"TOUCH_DISPLAY":/a\
    "METER":"VU-Meter",\
    "METER_DOC":"All VU-Meters of active meter folder, (only worked if enabled '\''No screensaver while playing'\'')",\
    "LIST_EMPTY":"No VU-Meters in list. Revert back to random mode!",\
    "RANDOMSELECTION":"VU-Meters for list",\
    "RANDOMSELECTION_DOC":"Comma separated list of meter names for using, if '\''List'\'' selected.<br />Available meter list for copy and paste:<br /><br />",\
    "RANDOMINTERVAL":"Random Interval",\
    "RANDOMINTERVAL_DOC":"Time interval until the next meter is displayed",\
    "NEEDLE_CACHE":"Needle Cache",\
    "NEEDLE_CACHE_DOC":"A Raspberry with 1GB RAM and a display resolution of 1920x1080 or 1280x800 is hard at the memory limit. Therefore the cache has to be switched off, in order to save memory. Otherwise, no random or list mode is possible",\
    "SCREEN_WIDTH":"Screen resolution (width)",\
    "SCREEN_WIDTH_DOC":"The specification of the screen resolution is only necessary for the use of a '\''custom folder'\'' with background image",\
    "SCREEN_HEIGHT":"Screen resolution (height)",\
    "SCREEN_HEIGHT_DOC":"The specification of the screen resolution is only necessary for the use of a '\''custom folder'\'' with background image",\
    "ACTIVE_FOLDER":"Active meter folder",\
    "ACTIVE_FOLDER_DOC":"Selection of the actively used folder for VU-Meter (in addition the specification of screen resolution is necessary for the '\''Custom-Folder'\'' with background image)",' $STR
fi
STR=/data/plugins/miscellanea/touch_display/i18n/strings_fr.json
if ! grep -q 'VU-mètres' $STR; then
	cp -f $STR backup/i18n
	sudo sed -i '/"TOUCH_DISPLAY":/a\
    "METER":"VU-mètres",\
    "METER_DOC":"Tous les VU-mètres dans le dossier des compteurs actifs (ne fonctionnait que si activé '\''Pas d'\''économiseur d'\''écran lors de la lecture'\''",\
    "LIST_EMPTY":"Aucun VU-mètre dans la liste. Revenez en mode aléatoire!",\
    "RANDOMSELECTION":"VU-mètres pour liste",\
    "RANDOMSELECTION_DOC":"Liste de noms de compteurs séparés par des virgules à utiliser, si la liste est sélectionnée.<br />Liste des compteurs disponibles pour copier et coller:<br /><br />",\
    "RANDOMINTERVAL":"Intervalle aléatoire",\
    "RANDOMINTERVAL_DOC":"Intervalle de temps jusqu'\''à ce que le prochain VU-mètre soit affiché",\
    "NEEDLE_CACHE":"Needle Cache",\
    "NEEDLE_CACHE_DOC":"Un Raspberry avec 1 Go de RAM et une résolution d'\''affichage de 1920x1080 or 1280x800 est dur à la limite de mémoire. Par conséquent, le cache doit être désactivé afin d'\''économiser de la mémoire. Sinon, aucun mode aléatoire ou liste n'\''est possible",\
    "SCREEN_WIDTH":"Résolution d'\''écran (largeur)",\
    "SCREEN_WIDTH_DOC":"La spécification de la résolution d'\''écran n'\''est nécessaire que pour l'\''utilisation d'\''un '\''custom folder'\'' avec image de fond",\
    "SCREEN_HEIGHT":"Résolution d'\''écran (hauteur)",\
    "SCREEN_HEIGHT_DOC":"La spécification de la résolution d'\''écran n'\''est nécessaire que pour l'\''utilisation d'\''un '\''custom folder'\'' avec image de fond",\
    "ACTIVE_FOLDER":"Dossier de compteur actif",\
    "ACTIVE_FOLDER_DOC":"Sélection du dossier activement utilisé pour VU-Meter (en outre, la spécification de la résolution d'\''écran est nécessaire pour le '\''Custom-Folder'\'' avec image de fond",' $STR
fi

UIC=/data/plugins/miscellanea/touch_display/UIConfig.json
UICT=/data/plugins/miscellanea/touch_display/UIConfig_tmp.json
[ ! -d "backup/touch" ] && mkdir backup/touch
if ! grep -q 'meter' $UIC; then
	cp -f $UIC backup/touch
	awk 'NR==FNR{if ($0 ~ /saveScreensaverConf/){c=NR};next}
	{if (FNR==(c+4)){print "\
                                      \"meter\",\n\
                                      \"randomSelection\",\n\
                                      \"randomInterval\",\n\
                                      \"needleCache\",\n\
                                      \"activeFolder\",\n\
                                      \"screenWidth\",\n\
                                      \"screenHeight\","\
	}};1' $UIC $UIC > $UICT && mv $UICT $UIC
fi
if ! grep -q '"id": "activeFolder"' $UIC; then
	awk 'NR==FNR{if ($0 ~ /brightness_conf/){c=NR};next}
	{if (FNR==(c-4)){print "\
                             },\n\
                             {\n\
                             \"id\": \"activeFolder\","\
	}};1' $UIC $UIC > $UICT && mv $UICT $UIC	
	sed -i '/"id": "activeFolder"/a\
                             "element": "select",\
                             "doc": "TRANSLATE.TOUCH_DISPLAY.ACTIVE_FOLDER_DOC",\
                             "label": "TRANSLATE.TOUCH_DISPLAY.ACTIVE_FOLDER",\
                             "visibleIf": {"field": "afterPlay", "value": true},\
                             "value": {"value": "medium", "label": "Medium" },\
                               "options": [\
                                 {\
                                    "value": "small",\
                                    "label": "Small (1 channel 320x240)"\
                                 },\
                                 {\
                                    "value": "medium",\
                                    "label": "Medium (1 channel 480x320)"\
                                 },\
                                 {\
                                    "value": "large",\
                                    "label": "Large (1 channel 800x480)"\
                                 },\
                                 {\
                                    "value": "wide",\
                                    "label": "Wide (2 channels 1280x400)"\
                                 }\
                               ]\
                             },\
                             {\
                             "id": "screenWidth",\
                             "element": "input",\
                             "type": "number",\
                             "doc": "TRANSLATE.TOUCH_DISPLAY.SCREEN_WIDTH_DOC",\
                             "label": "TRANSLATE.TOUCH_DISPLAY.SCREEN_WIDTH",\
                             "attributes": [\
                                             {"placeholder": {}},\
                                             {"maxlength": {}},\
                                             {"min": {}},\
                                             {"max": {}}\
                                           ],\
                             "value": "1920",\
                             "visibleIf": {"field": "afterPlay", "value": true}\
                             },\
                             {\
                             "id": "screenHeight",\
                             "element": "input",\
                             "type": "number",\
                             "doc": "TRANSLATE.TOUCH_DISPLAY.SCREEN_HEIGHT_DOC",\
                             "label": "TRANSLATE.TOUCH_DISPLAY.SCREEN_HEIGHT",\
                             "attributes": [\
                                             {"placeholder": {}},\
                                             {"maxlength": {}},\
                                             {"min": {}},\
                                             {"max": {}}\
                                           ],\
                             "value": "1080",\
                             "visibleIf": {"field": "afterPlay", "value": true}\
                             },\
                             {\
                             "id": "needleCache",\
                             "element": "switch",\
                             "doc": "TRANSLATE.TOUCH_DISPLAY.NEEDLE_CACHE_DOC",\
                             "label": "TRANSLATE.TOUCH_DISPLAY.NEEDLE_CACHE",\
                             "value": true,\
                             "visibleIf": {"field": "afterPlay", "value": true}\
                             },\
                             {\
                             "id": "meter",\
                             "element": "select",\
                             "doc": "TRANSLATE.TOUCH_DISPLAY.METER_DOC",\
                             "label": "TRANSLATE.TOUCH_DISPLAY.METER",\
                             "visibleIf": {"field": "afterPlay", "value": true},\
                             "value": {"value": "random", "label": "Random" },\
                               "options": [\
                                 {\
                                    "value": "random",\
                                    "label": "Random"\
                                 },\
                                 {\
                                    "value": "list",\
                                    "label": "List"\
                                 }\
                               ]\
                             },\
                             {\
                             "id": "randomSelection",\
                             "element": "input",\
                             "type": "string",\
                             "doc": "TRANSLATE.TOUCH_DISPLAY.RANDOMSELECTION_DOC",\
                             "label": "TRANSLATE.TOUCH_DISPLAY.RANDOMSELECTION",\
                             "value": "",\
                             "visibleIf": {"field": "afterPlay", "value": true}\
                             },\
                             {\
                             "id": "randomInterval",\
                             "element": "input",\
                             "type": "number",\
                             "doc": "TRANSLATE.TOUCH_DISPLAY.RANDOMINTERVAL_DOC",\
                             "label": "TRANSLATE.TOUCH_DISPLAY.RANDOMINTERVAL",\
                             "attributes": [\
                                             {"placeholder": {}},\
                                             {"maxlength": {}},\
                                             {"min": {}},\
                                             {"max": {}}\
                                           ],\
                             "value": 120,\
                             "visibleIf": {"field": "afterPlay", "value": true}' $UIC
fi

# add new content to config.json
conf=/data/plugins/miscellanea/touch_display/config.json
if ! grep -q 'randomSelection' $conf; then
	cp $conf backup/touch
	sed -i '/"timeout"/i\
  "randomSelection": {\
    "value":"",\
    "type":"string"\
  },\
  "activeFolder": {\
    "value":"medium",\
    "type":"string"\
  },\
  "activeFolder_title": {\
    "value":"Medium",\
    "type":"string"\
  },\
  "screenWidth": {\
    "value":"320",\
    "type":"number"\
  },\
  "screenHeight": {\
    "value":"240",\
    "type":"number"\
  },' $conf
fi
conf=/data/configuration/miscellanea/touch_display/config.json
if ! grep -q 'randomSelection' $conf; then
	sed -i '/"timeout"/i\
  "randomSelection": {\
    "value":"",\
    "type":"string"\
  },\
  "activeFolder": {\
    "value":"medium",\
    "type":"string"\
  },\
  "activeFolder_title": {\
    "value":"Medium",\
    "type":"string"\
  },\
  "screenWidth": {\
    "value":"320",\
    "type":"number"\
  },\
  "screenHeight": {\
    "value":"240",\
    "type":"number"\
  },' $conf
fi

  
TSC=/data/plugins/miscellanea/touch_display/index.js
if ! grep -q 'dependencies for meters' $TSC; then
	cp -f $TSC backup/touch
	sed -i '/use strict'\'';/a\
// ---> dependencies for meters\
const ini = require("ini");\
const PeppyPath = "/home/volumio/PeppyMeter/"\
// <---' $TSC
fi

if ! grep -q 'start crontab for meter' $TSC; then
	sed -i '/(self.config.get('\''afterPlay'\'')/a\
// --->  start crontab for meter\
          exec("crontab -r");\
          exec('\''echo "*/'\'' + self.config.get("timeout")/60 + '\'' * * * * /home/volumio/PeppyMeter/run_peppymeter.sh > /dev/null 2>&1" | crontab'\'');\
// <---' $TSC
fi

if ! grep -q 'delete crontab for meter' $TSC; then
	sed -i '/self.setScreenTimeout(self.config.get('\''timeout'\'')/i\
// --->  delete crontab for meter\
          exec("crontab -r");\
// <---' $TSC
fi

if ! grep -q 'UI-Integration meters - read values' $TSC; then
	sed -i '/uiconf.sections\[0\].content\[1\].value/a\
// ---> UI-Integration meters - read values\
    var config_file = PeppyPath + "config.txt";\
    if (fs.existsSync(config_file)){\
      // read values from ini\
      var config = ini.parse(fs.readFileSync(config_file, "utf-8")),\
          meters_file = PeppyPath + config.current["meter.size"] + "/meters.txt",\
          upperc = /\\b([^-])/g;\
\
      // active folder\
      // fill selection list with custom folders\
      var files = fs.readdirSync(PeppyPath);\
      files.forEach(file => {\
        var stat = fs.statSync(PeppyPath + file);\
        if (stat.isDirectory() && file.startsWith ("custom")) {\
            self.configManager.pushUIConfigParam(uiconf, "sections[0].content[2].options", {\
                value: file,\
                label: file.replace(upperc, c => c.toUpperCase())\
            });\
        }\
      });\
      if (self.config.get("activeFolder") == "") {\
        uiconf.sections[0].content[2].value.value = config.current["meter.size"];\
        uiconf.sections[0].content[2].value.label = (uiconf.sections[0].content[2].value.value).replace(upperc, c => c.toUpperCase());\
      } else {\
        uiconf.sections[0].content[2].value.value = self.config.get("activeFolder");\
        uiconf.sections[0].content[2].value.label = self.config.get("activeFolder_title");\
      }\
\
      // screen width/height\
      uiconf.sections[0].content[3].value = self.config.get("screenWidth");\
      uiconf.sections[0].content[3].attributes = [\
        {\
            placeholder: 1920,\
            maxlength: 4,\
            min: 320,\
            max: Number.MAX_SAFE_INTEGER\
        }\
      ];\
      uiconf.sections[0].content[4].value = self.config.get("screenHeight");\
      uiconf.sections[0].content[4].attributes = [\
        {\
            placeholder: 1080,\
            maxlength: 4,\
            min: 240,\
            max: Number.MAX_SAFE_INTEGER\
        }\
      ];\
\
      // needle cache\
      var needleCache = (config.current["use.cache"]).toLowerCase() == "true" ? true : false;\
      uiconf.sections[0].content[5].value = needleCache;\
\
      if (fs.existsSync(meters_file)){\
        var metersconfig = ini.parse(fs.readFileSync(meters_file, "utf-8")),\
            availMeters = "";\
\
        // current meter\
        if ((config.current.meter).includes(",")) {\
            uiconf.sections[0].content[6].value.value = "list";\
        } else {\
            uiconf.sections[0].content[6].value.value = config.current.meter;\
        }\
        uiconf.sections[0].content[6].value.label = (uiconf.sections[0].content[6].value.value).replace(upperc, c => c.toUpperCase());\
\
        // read all sections from active meters.txt and fill selection list\
        for (var section in metersconfig) {\
          availMeters += section + ",";\
          self.configManager.pushUIConfigParam(uiconf, "sections[0].content[6].options", {\
            value: section,\
            label: section.replace(upperc, c => c.toUpperCase())\
          });\
        }\
\
        // list selection\
        availMeters = availMeters.substring(0, availMeters.length -1);\
        uiconf.sections[0].content[7].value = self.config.get("randomSelection");\
        uiconf.sections[0].content[7].doc = self.commandRouter.getI18nString("TOUCH_DISPLAY.RANDOMSELECTION_DOC") + "<b>" + availMeters + "</b>";\
\
        // random interval\
        uiconf.sections[0].content[8].value = parseInt(config.current["random.meter.interval"], 10);\
        uiconf.sections[0].content[8].attributes = [\
            {\
              placeholder: 60,\
              maxlength: Number.MAX_SAFE_INTEGER.toString().length,\
              min: 15,\
              max: Number.MAX_SAFE_INTEGER\
            }\
        ];\
      }\
    }\
\
    //console.log(config.current["random.meter.interval"]);\
// <---' $TSC
fi

TSCT=/data/plugins/miscellanea/touch_display/index_tmp.js
if ! grep -q 'UI-Integration meters - write values' $TSC; then
	awk 'NR==FNR{if ($0 ~ /self.setScreenTimeout\(confData.timeout, true\)/){c=NR};next}
	{if (FNR==(c+5)){print "// ---> UI-Integration meters - write values"}};1' $TSC $TSC > $TSCT
	sed -i '/UI-Integration meters - write values/a\
  if (fs.existsSync(PeppyPath + "config.txt")){\
    var config = ini.parse(fs.readFileSync(PeppyPath + "config.txt", "utf-8"));\
    // write selected meter\
    if ((confData.meter.value !== "list" && config.current.meter !== confData.meter.value) || (confData.meter.value == "list" && config.current.meter !== confData.randomSelection)) {\
        if (confData.meter.value === "list") {\
            if (confData.randomSelection !== ""){\
                config.current.meter = (confData.randomSelection).toLowerCase();\
                self.config.set("randomSelection", (confData.randomSelection).toLowerCase());\
            } else {\
                setTimeout(function () {\
                    self.commandRouter.pushToastMessage("error", self.commandRouter.getI18nString("TOUCH_DISPLAY.PLUGIN_NAME"), self.commandRouter.getI18nString("TOUCH_DISPLAY.LIST_EMPTY"));\
                }, 500);\
                uiNeedsUpdate = true;\
                config.current.meter = "random";\
            }\
        } else {\
            config.current.meter = confData.meter.value;\
        }\
        noChanges = false;\
    }\
    // write random interval\
    if (Number.isNaN(parseInt(confData.randomInterval, 10)) || !isFinite(confData.randomInterval)) {\
        uiNeedsUpdate = true;\
        setTimeout(function () {\
            self.commandRouter.pushToastMessage("error", self.commandRouter.getI18nString("TOUCH_DISPLAY.PLUGIN_NAME"), self.commandRouter.getI18nString("TOUCH_DISPLAY.RANDOMINTERVAL") + self.commandRouter.getI18nString("TOUCH_DISPLAY.NAN"));\
        }, 500);\
    } else {\
        confData.randomInterval = self.checkLimits("RANDOMINTERVAL", confData.randomInterval, 15, Number.MAX_SAFE_INTEGER);\
        if (config.current["random.meter.interval"] != confData.randomInterval) {\
            config.current["random.meter.interval"] = confData.randomInterval;\
            noChanges = false;\
        }\
    }\
    // write needle cache\
    var needleCache = confData.needleCache? "True" : "False";\
    if (config.current["use.cache"] !== needleCache) {\
        config.current["use.cache"] = needleCache;\
        noChanges = false;\
    }\
    // write screen width/height\
    if (self.config.get("screenWidth") !== confData.screenWidth || self.config.get("screenHeight") !== confData.screenHeight || config.current["meter.size"] !== confData.activeFolder.value){\
        if (Number.isNaN(parseInt(confData.screenWidth, 10)) || !isFinite(confData.screenWidth)) {\
            uiNeedsUpdate = true;\
            setTimeout(function () {\
                self.commandRouter.pushToastMessage("error", self.commandRouter.getI18nString("TOUCH_DISPLAY.PLUGIN_NAME"), self.commandRouter.getI18nString("TOUCH_DISPLAY.SCREEN_WIDTH") + self.commandRouter.getI18nString("TOUCH_DISPLAY.NAN"));\
            }, 500);\
        } else {\
            confData.screenWidth = self.checkLimits("SCREEN_WIDTH", confData.screenWidth, 320, Number.MAX_SAFE_INTEGER);\
            self.config.set("screenWidth", confData.screenWidth);\
            config.current["screen.width"] = (confData.activeFolder.value).startsWith("custom")? confData.screenWidth : "";\
            noChanges = false;\
        }\
        if (Number.isNaN(parseInt(confData.screenHeight, 10)) || !isFinite(confData.screenHeight)) {\
            uiNeedsUpdate = true;\
            setTimeout(function () {\
                self.commandRouter.pushToastMessage("error", self.commandRouter.getI18nString("TOUCH_DISPLAY.PLUGIN_NAME"), self.commandRouter.getI18nString("TOUCH_DISPLAY.SCREEN_HEIGHT") + self.commandRouter.getI18nString("TOUCH_DISPLAY.NAN"));\
            }, 500);\
        } else {\
            confData.screenHeight = self.checkLimits("SCREEN_HEIGHT", confData.screenHeight, 240, Number.MAX_SAFE_INTEGER);\
            self.config.set("screenHeight", confData.screenHeight);\
            config.current["screen.height"] = (confData.activeFolder.value).startsWith("custom")? confData.screenHeight : "";\
            noChanges = false;\
        }\
    }\
    // write active folder\
    if (config.current["meter.size"] !== confData.activeFolder.value) {\
        config.current["meter.size"] = confData.activeFolder.value;\
        self.config.set("activeFolder", confData.activeFolder.value);\
        self.config.set("activeFolder_title", confData.activeFolder.label);\
        // reset active meter\
        config.current.meter = "random";\
        self.config.set("randomSelection", "");\
        noChanges = false;\
        uiNeedsUpdate = true;\
    }\
\
    if (!noChanges) {\
        fs.writeFileSync(PeppyPath + "config.txt", ini.stringify(config, {whitespace: true}));\
        if (uiNeedsUpdate) {\
            self.commandRouter.pushToastMessage("success", self.commandRouter.getI18nString("TOUCH_DISPLAY.PLUGIN_NAME"), self.commandRouter.getI18nString("COMMON.SETTINGS_SAVED_SUCCESSFULLY"));\
        }\
    }\
  }\
// <---' $TSCT && mv $TSCT $TSC
fi

#TouchDisplay.prototype.getConfigParam = function (key) {
#  var self = this;
#  return self.config.get(key);
#};

#TouchDisplay.prototype.setConfigParam = function (data) {
#  var self = this;
#  self.config.set(data.key, data.value);
#};

volumio vrestart